﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WindowsFormsApplication1
{
    //Enumerador para modo del dibujo, con relleno o sin relleno
    public enum FillMode
    {
        Empty,
        Filled
    }

    public class Circle
    {
        public int Ratio { get; private set; }//radio
        public Point Center { get; private set; }//punto centro

        //rectangulo que representa el area donde se dibujara el circulo
        //es mas facil tenerlo como varible dentro de la calse circulo, asi a la hora de dibujar
        //es mas facil y logras circulos variados
        public Rectangle Bounds { get; private set; }

        //Para manejar el color y grsor del trazado
        public Pen Pen { get; set; }

        //modo de savizado del trazado
        public SmoothingMode SmoothingMode { get; set; }

        //modo del dibujo, con relleno o sin relleno
        public FillMode FillMode { get; set; }


        public Circle(Point center)
        {
            this.Center = center;
            this.Pen = new Pen(Color.Black, 1);
        }

        //Esta funcion calcula el radio de la circunferencia partiendo desde el centro
        public void UpdateRatio(Point endPoint)
        {
            Ratio = (int)Math.Sqrt(Math.Pow(Center.X - endPoint.X, 2) + Math.Pow(Center.Y - endPoint.Y, 2));
            Bounds = new Rectangle(Center.X - Ratio, Center.Y - Ratio, Ratio * 2, Ratio * 2);
        }
    }
}
