﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        //para chequear cuando se esta dibujando
        private bool drawing;
        //lista para almacenar los dibujos
        private List<Circle> circles;

        public Form1()
        {
            InitializeComponent();
            circles = new List<Circle>();

            //popula los selectores con los enumerados correspondientes
            comboBoxSMode.DataSource = Enum.GetValues(typeof(SmoothingMode));
            comboBoxFillMode.DataSource = Enum.GetValues(typeof(FillMode));
        }

        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            //se crea el objeto circulo y se agrega a la lista
            circles.Add(new Circle(e.Location));


            //teniendo en cuenta que el circulo recien creado y agregado a la lista esta en la ultima posicion de esta
            //pues, lo localizamos y establecemos las propiedades deseadas
            circles[circles.Count - 1].SmoothingMode = (SmoothingMode)comboBoxSMode.SelectedValue;
            circles[circles.Count - 1].Pen.Color = pictureBoxColor.BackColor;
            circles[circles.Count - 1].Pen.Width = (float)numericUpDown1.Value;
            circles[circles.Count - 1].FillMode = (FillMode)comboBoxFillMode.SelectedValue;

            //comineza el dibujo
            drawing = true;
        }

        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            if (drawing)
            {
                //con cada posicion nueva del cursor tendremos que calcular el radio de la circunferencia
                circles[circles.Count - 1].UpdateRatio(e.Location);

                //fuerza al picturebox a que se repinte
                pictureBox1.Invalidate();
            }
        }

        private void pictureBox1_MouseUp(object sender, MouseEventArgs e)
        {
            //termina el dibujo y fuerza al picturebox a que se repinte
            drawing = false;
            pictureBox1.Invalidate();
        }

        private void pictureBox1_Paint(object sender, PaintEventArgs e)
        {
            //se recorre la lista con las circunferencias creadas y se dibuja una por una
            for (int i = 0; i < circles.Count; i++)
            {
                try
                {
                    //establece los modos del trazado
                    //es necesario en este caso un control de excepciones dado a que el modo "Invalid" daria un error de ejecucion en este caso
                    e.Graphics.SmoothingMode = circles[i].SmoothingMode;
                }
                catch { }

                /*NOTA:
                 *Aunque la clase se llama circle, en realidad un circulo es una circunferencia rellena con algun color
                 *si solo dibujamos el contorno pues eso se llama circunferencia
                 */

                //si queremos solo la circunferencia dibujamos solo el contorno
                if (circles[i].FillMode == FillMode.Empty)
                {
                    e.Graphics.DrawEllipse(circles[i].Pen, circles[i].Bounds);
                }
                else if (circles[i].FillMode == FillMode.Filled)//si queremos un circulo, pues rellenamos la circunferencia
                {
                    e.Graphics.FillEllipse(new SolidBrush(circles[i].Pen.Color), circles[i].Bounds);
                }
            }
        }

        private void pictureBoxColor_Click(object sender, EventArgs e)
        {
            //para seleccionar el color
            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                pictureBoxColor.BackColor = colorDialog1.Color;
            }
        }

        //limpia el area de dibujo
        private void button1_Click(object sender, EventArgs e)
        {
            circles.Clear();
            pictureBox1.Invalidate();
        }
    }
}
